﻿
package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.geom.ColorTransform;
	import flash.utils.getTimer;
	import flash.geom.*;
	import flash.geom.Matrix; 
    import flash.display.GradientType;

	public class Vortexer extends Sprite
	{
		var nombre:Number;
		
		private var downPoint:Point;
		private var upPoint:Point;
		private var startTime:int;
		private var endTime:int;
		private var dx:Number;
		private var dy:Number;
		private var distance:Number;
		private var modulo:Number= 400;
		private var inv:Number= 1;
		private var inca:Number = 0;
		private var red:Number;
		private var green:Number;
		private var blue:Number;
		var anglea:Number;
		var deltaTime:int;
		
		public function Vortexer()
		{

			addEventListener(Event.ADDED_TO_STAGE,added_handler);
		}
		private function added_handler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
			
			downPoint=new Point  ;
			upPoint=new Point  ;
			
		}
		private function down_handler(e:MouseEvent):void
		{
			if( nombre != 0 ){
				for(var i:Number=0;i<nombre;i+=.01){
					var col:DisplayObject = getChildByName("collin"+i);
					
					downPoint.x=mouseX;
					downPoint.y=mouseY;
					startTime=getTimer();
					
				}
			}
			nombre = 0;
			stage.addEventListener(MouseEvent.MOUSE_MOVE,move_handler);
		}
		private function up_handler(e:MouseEvent):void
		{
			
			upPoint.x=mouseX;
			upPoint.y=mouseY;
			dx=upPoint.x - downPoint.x;
			dy=upPoint.y - downPoint.y;
			anglea =180 / Math.PI * Math.atan2(dy,dx) + 180;
			distance=Point.distance(upPoint,downPoint);
			endTime=getTimer();
			deltaTime = endTime - startTime;
			
			trace(deltaTime);
			
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,move_handler);
			
		}
		private function move_handler(e:MouseEvent):void
		{
			
			var gradientBoxMatrix :Matrix = new Matrix();
  			gradientBoxMatrix.createGradientBox (200, 40, 0, 0, 0);
			
			var collin :Collin = new Collin();
			collin.name = "collin" + nombre;
			collin.x = mouseX;
			collin.y = mouseY;
			collin.long = 0;
			collin.angle = 10;
			var couleur:uint = 0xffffff;
			collin.graphics.lineStyle(9,couleur,.3);
			
			collin.graphics.lineGradientStyle(GradientType.RADIAL, [0xFF0000, 0xff0000, 0x000000], [1, 1, 1], [0, 128, 255], gradientBoxMatrix);

			for(var i:Number=0;i<nombre;i+=0.3){
    		collin.graphics.lineTo(Math.pow(i,1.2)*Math.cos(i), Math.pow(i,1.2)*Math.sin(i));
			
			}
			
			var gradientBoxMatrixa:Matrix = new Matrix();
  			gradientBoxMatrixa.createGradientBox(e.currentTarget.width*2, e.currentTarget.height*2, 0, e.currentTarget.width*2, e.currentTarget.height*2);
			
			var collina :Collin = new Collin();
			collina.name = "collin" + nombre;
			collina.x = mouseX;
			collina.y = mouseY;
			collina.long = 0;
			collina.angle = 10;
			var couleura:uint = 0xffffff;
			collina.graphics.lineStyle(7*(nombre*.1),couleura,.5);
			
			collina.graphics.lineGradientStyle(GradientType.LINEAR, [0xffffff, 0x000000, 0xfffff], [.1, .7, .8], [0, 128, 255], gradientBoxMatrix);
			
			collina.graphics.moveTo (e.currentTarget.width*(nombre*.01),e.currentTarget.height*(nombre*.01));
    		collina.graphics.lineTo(e.currentTarget.width/2*(nombre*.01),e.currentTarget.height/2*(nombre*.01));
			
			collin.addEventListener (Event.ENTER_FRAME,enter_handler);
			addChild(collin);
			collina.addEventListener(Event.ENTER_FRAME,enter_handler);
			addChild(collina);
			
			if (nombre <= 30){
			nombre++;
			}
			else{(stage.removeEventListener(MouseEvent.MOUSE_MOVE,move_handler))}
			
		}
		private function enter_handler(e:Event):void
		{

				e.currentTarget.rotation += 3*(deltaTime*0.01)/8;
			
				   if (anglea > 45 && anglea < 135) {

				e.currentTarget.y -= .5;

			} else if (anglea > 225 && anglea < 315) {

				e.currentTarget.y += .5;

			} else if (anglea > 135 && anglea < 225) {

				e.currentTarget.x += .5;

			} else if (anglea > 0 && anglea < 45 || anglea > 315 && anglea < 360) {

				e.currentTarget.x -= .5;

			}
			
			if (e.currentTarget.x >= stage.stageWidth - mouseX && e.currentTarget.x <= 0 - mouseX && e.currentTarget.y >= stage.stageHeight - mouseY && e.currentTarget.y <= 0 - mouseY){
				stage.removeEventListener(Event.ENTER_FRAME,enter_handler)
			}
		}
	}
}
import flash.display.Sprite;
class Collin extends Sprite{
	public var long:Number;
	public var angle:Number;
	public var posx:Number;
	function Collin(){
	}
}